//
//  ListRightVariablePriceChangeAllTextAndLinksModel.swift
//  MVMCoreUI
//
//  Created by Kruthika KP on 13/04/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//


public class ListRightVariablePriceChangeAllTextAndLinksModel: ListItemModel, MoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    
    public static var identifier: String = "listRVArwAll"
    public var eyebrowHeadlineBodyLink: EyebrowHeadlineBodyLinkModel
    public var rightLabel: LabelModel
    public var arrow: ArrowModel
    
    //-----------------------------------------------------
    // MARK: - Methods
    //-----------------------------------------------------
    
    override public func setDefaults() {
        super.setDefaults()
        if rightLabel.numberOfLines == nil {
            rightLabel.numberOfLines = 1
        }
    }
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    
    public init(eyebrowHeadlineBodyLink: EyebrowHeadlineBodyLinkModel, rightLabel: LabelModel, arrow: ArrowModel) {
        self.eyebrowHeadlineBodyLink = eyebrowHeadlineBodyLink
        self.rightLabel = rightLabel
        self.arrow = arrow
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case eyebrowHeadlineBodyLink
        case rightLabel
        case arrow
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        eyebrowHeadlineBodyLink = try typeContainer.decode(EyebrowHeadlineBodyLinkModel.self, forKey: .eyebrowHeadlineBodyLink)
        rightLabel = try typeContainer.decode(LabelModel.self, forKey: .rightLabel)
        arrow = try typeContainer.decode(ArrowModel.self, forKey: .arrow)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(eyebrowHeadlineBodyLink, forKey: .eyebrowHeadlineBodyLink)
        try container.encode(rightLabel, forKey: .rightLabel)
        try container.encode(arrow, forKey: .arrow)
    }
}
